--- features2d.old.hpp	2013-10-14 08:28:48.000000000 -0700
+++ features2d.hpp	2013-10-15 22:21:52.000000000 -0700
@@ -454,9 +454,14 @@
 protected:
     virtual void computeImpl( const Mat& image, vector<KeyPoint>& keypoints, Mat& descriptors ) const;
     void buildPattern();
-    uchar meanIntensity( const Mat& image, const Mat& integral, const float kp_x, const float kp_y,
+    
+    template <typename imgType, typename iiType>
+    int meanIntensity( const Mat& image, const Mat& integral, const float kp_x, const float kp_y,
                          const unsigned int scale, const unsigned int rot, const unsigned int point ) const;
 
+    template <typename srcMatType, typename iiMatType>
+    void computeDescriptors( const Mat& image, std::vector<KeyPoint>& keypoints, Mat& descriptors ) const;
+    
     bool orientationNormalized; //true if the orientation is normalized, false otherwise
     bool scaleNormalized; //true if the scale is normalized, false otherwise
     double patternScale; //scaling of the pattern
